"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGBehaviorFactory subclass:#RGMetaclassTrait
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGMetaclassTrait comment:'A factory that produces instances of RG2Behavior composed with RGMetaclassTraitStrategy'
!

!RGMetaclassTrait class methodsFor:'instance creation'!

newStrategy

    ^ RGMetaclassTraitStrategy unresolved
!

newStrategyFor: anRGEnvironment

    ^ (self strategyClassForVersion: anRGEnvironment version) unresolved
!

strategyClassForVersion: aVersionNumber

    ^ (aVersionNumber <= 6)
        ifTrue: [ RGMetaclassTraitStrategy ]
        ifFalse: [ RGMetaclassTraitV2Strategy ]
! !

