"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGVariable subclass:#RGSlot
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGSlot comment:''
!

!RGSlot methodsFor:'accessing'!

definitionString

    ^ String streamContents: [ :aStream |
        aStream nextPutAll: '#'; nextPutAll: self name]
!

name: aString

    self parent parent announceDefinitionChangeDuring: [ 
        super name: aString ].
! !

!RGSlot methodsFor:'bootstrap'!

accept: anInterpreter assign: aValue inNode: aVariableNode
    self error: #TBD
! !

!RGSlot methodsFor:'managing container'!

addoptToParentStub

    super addoptToParentStub.
    self parent addSlot: self.
!

defaultParentStub

    ^ self defaultFixedLayoutStub
! !

!RGSlot methodsFor:'testing'!

isInstanceVariable
    ^ true
! !

!RGSlot methodsFor:'testing types'!

isSlot

    ^ true
! !

!RGSlot methodsFor:'visiting'!

acceptVisitor: aProgramNodeVisitor node: aNode 
    ^ aProgramNodeVisitor visitInstanceVariableNode: aNode
! !

